<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/common/encoding.hpp File Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('df/d57/encoding_8hpp.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">encoding.hpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file includes definitions for byte-ordering encoding.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;limits.h&gt;</code><br />
<code>#include &lt;stdint.h&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for encoding.hpp:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/dbe/encoding_8hpp__incl.png" border="0" usemap="#src_2core_2common_2encoding_8hpp" alt=""/></div>
<map name="src_2core_2common_2encoding_8hpp" id="src_2core_2common_2encoding_8hpp">
<area shape="rect" id="node3" href="../../df/dd8/stdint_8h_source.html" title="stdint.h" alt="" coords="121,79,185,104"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d4e/encoding_8hpp__dep__incl.png" border="0" usemap="#src_2core_2common_2encoding_8hppdep" alt=""/></div>
<map name="src_2core_2common_2encoding_8hppdep" id="src_2core_2common_2encoding_8hppdep">
<area shape="rect" id="node2" href="../../dd/d48/cli_8cpp.html" title="This file implements the CLI interpreter. " alt="" coords="4261,579,4358,604"/>
<area shape="rect" id="node3" href="../../db/d13/cli__uart_8cpp.html" title="This file implements the CLI server on the UART service. " alt="" coords="38,85,166,111"/>
<area shape="rect" id="node4" href="../../d9/dd6/coap__header_8cpp.html" title="This file implements the CoAP header generation and parsing. " alt="" coords="595,325,729,364"/>
<area shape="rect" id="node5" href="../../d1/d8d/coap__header_8hpp.html" title="This file includes definitions for generating and processing CoAP headers. " alt="" coords="1079,239,1213,277"/>
<area shape="rect" id="node10" href="../../d4/d64/joiner_8cpp.html" title="This file implements the Joiner role. " alt="" coords="2806,499,2993,524"/>
<area shape="rect" id="node12" href="../../db/dc3/joiner__router_8cpp.html" title="This file implements the Joiner Router role. " alt="" coords="2616,572,2779,611"/>
<area shape="rect" id="node13" href="../../d0/d78/mle_8hpp.html" title="This file includes definitions for MLE functionality required by the Thread Child, Router, and Leader roles. " alt="" coords="3221,499,3383,524"/>
<area shape="rect" id="node14" href="../../d1/df9/mle_8cpp.html" title="This file implements MLE functionality required for the Thread Child, Router and Leader roles..." alt="" coords="3368,752,3529,777"/>
<area shape="rect" id="node17" href="../../de/d27/address__resolver_8cpp.html" title="This file implements Thread&#39;s EID&#45;to&#45;RLOC mapping and caching. " alt="" coords="353,745,515,784"/>
<area shape="rect" id="node18" href="../../df/d6b/mesh__forwarder_8cpp.html" title="This file implements mesh forwarding of IPv6/6LoWPAN messages. " alt="" coords="4050,745,4196,784"/>
<area shape="rect" id="node19" href="../../d9/d88/mle__router_8cpp.html" title="This file implements MLE functionality required for the Thread Router and Leader roles. " alt="" coords="4501,745,4636,784"/>
<area shape="rect" id="node20" href="../../d0/d0f/network__data__leader_8cpp.html" title="This file implements the Thread Network Data managed by the Thread Leader. " alt="" coords="2750,745,2910,784"/>
<area shape="rect" id="node21" href="../../d1/da2/network__diag_8cpp.html" title="This file implements Thread&#39;s Network Diagnostic processing. " alt="" coords="579,745,740,784"/>
<area shape="rect" id="node22" href="../../db/d84/thread__netif_8cpp.html" title="This file implements the Thread network interface. " alt="" coords="3782,659,3934,697"/>
<area shape="rect" id="node23" href="../../d8/d26/thread__tlvs_8hpp.html" title="This file includes definitions and methods for generating and processing Thread Network Layer TLVs..." alt="" coords="3115,572,3267,611"/>
<area shape="rect" id="node28" href="../../dd/d3b/energy__scan__client_8cpp.html" title="This file implements the Energy Scan Client. " alt="" coords="1608,325,1779,364"/>
<area shape="rect" id="node33" href="../../d1/d97/mac__frame_8hpp.html" title="This file includes definitions for generating and processing IEEE 802.15.4 MAC frames. " alt="" coords="3354,85,3548,111"/>
<area shape="rect" id="node35" href="../../d1/dd4/ip6_8hpp.html" title="This file includes definitions for IPv6 packet processing. " alt="" coords="4241,499,4379,524"/>
<area shape="rect" id="node36" href="../../d4/d07/udp6_8cpp.html" title="This file implements UDP/IPv6 sockets. " alt="" coords="4382,579,4531,604"/>
<area shape="rect" id="node37" href="../../d6/d2b/lowpan_8cpp.html" title="This file implements 6LoWPAN header compression. " alt="" coords="4606,579,4787,604"/>
<area shape="rect" id="node38" href="../../db/d51/ip6__headers_8hpp.html" title="This file includes definitions for IPv6 packet processing. " alt="" coords="4262,332,4456,357"/>
<area shape="rect" id="node39" href="../../d0/dba/icmp6_8hpp.html" title="This file includes definitions for ICMPv6. " alt="" coords="4348,419,4504,444"/>
<area shape="rect" id="node41" href="../../dd/d6b/meshcop__tlvs_8hpp.html" title="This file includes definitions for generating and processing MeshCoP TLVs. " alt="" coords="2494,239,2662,277"/>
<area shape="rect" id="node42" href="../../d1/df7/mle__tlvs_8hpp.html" title="This file includes definitions for generating and processing MLE TLVs. " alt="" coords="3350,325,3486,364"/>
<area shape="rect" id="node43" href="../../d5/d88/network__diag__tlvs_8hpp.html" title="This file includes definitions for generating and processing MLE TLVs. " alt="" coords="2400,325,2561,364"/>
<area shape="rect" id="node48" href="../../d2/db6/ip6__address_8cpp.html" title="This file implements IPv6 addresses. " alt="" coords="4204,165,4397,191"/>
<area shape="rect" id="node49" href="../../d2/d47/dtls_8cpp.html" title="This file implements the necessary hooks for mbedTLS. " alt="" coords="5064,85,5241,111"/>
<area shape="rect" id="node50" href="../../d1/d19/network__data__tlvs_8hpp.html" title="This file includes definitions for generating and processing Thread Network Data TLVs. " alt="" coords="5264,79,5425,117"/>
<area shape="rect" id="node6" href="../../dd/d28/coap__server_8hpp.html" title="This file includes definitions for the CoAP server. " alt="" coords="3091,325,3225,364"/>
<area shape="rect" id="node8" href="../../d7/d69/commissioner_8cpp.html" title="This file implements a Commissioner role. " alt="" coords="2698,665,2935,691"/>
<area shape="rect" id="node9" href="../../d0/d93/joiner_8hpp.html" title="This file includes definitions for the Joiner role. " alt="" coords="2857,419,3045,444"/>
<area shape="rect" id="node11" href="../../da/d7f/joiner__router_8hpp.html" title="This file includes definitions for the Joiner Router role. " alt="" coords="3070,412,3233,451"/>
<area shape="rect" id="node15" href="../../d6/d6f/mle__router_8hpp.html" title="This file includes definitions for MLE functionality required by the Thread Router and Leader roles..." alt="" coords="3342,659,3478,697"/>
<area shape="rect" id="node24" href="../../d7/d02/leader_8cpp.html" title="This file implements a MeshCoP Leader. " alt="" coords="798,665,990,691"/>
<area shape="rect" id="node25" href="../../df/d42/meshcop__dataset__manager_8cpp.html" title="This file implements MeshCoP Datasets manager to process commands. " alt="" coords="1615,659,1783,697"/>
<area shape="rect" id="node26" href="../../d9/d20/network__data_8cpp.html" title="This file implements common methods for manipulating Thread Network Data. " alt="" coords="2331,659,2492,697"/>
<area shape="rect" id="node27" href="../../d3/dd0/announce__begin__client_8cpp.html" title="This file implements the Announce Begin Client. " alt="" coords="1803,325,1992,364"/>
<area shape="rect" id="node29" href="../../d5/de7/panid__query__client_8cpp.html" title="This file implements the PAN ID Query Client. " alt="" coords="2016,325,2179,364"/>
<area shape="rect" id="node30" href="../../d4/d67/announce__begin__server_8cpp.html" title="This file implements the Announce Begin Server. " alt="" coords="2204,325,2376,364"/>
<area shape="rect" id="node31" href="../../da/d6e/energy__scan__server_8cpp.html" title="This file implements the Energy Scan Server. " alt="" coords="1259,325,1414,364"/>
<area shape="rect" id="node32" href="../../d1/d58/panid__query__server_8cpp.html" title="This file implements the PAN ID Query Server. " alt="" coords="1438,325,1584,364"/>
<area shape="rect" id="node7" href="../../d4/da4/commissioner_8hpp.html" title="This file includes definitions for the Commissioner role. " alt="" coords="2854,579,3091,604"/>
<area shape="rect" id="node16" href="../../d4/dd9/mac_8cpp.html" title="This file implements the subset of IEEE 802.15.4 primitives required for Thread. " alt="" coords="3591,752,3743,777"/>
<area shape="rect" id="node34" href="../../d5/d8c/message_8hpp.html" title="This file includes definitions for the message buffer pool and message buffers. " alt="" coords="3206,165,3414,191"/>
<area shape="rect" id="node40" href="../../d0/d86/netif_8hpp.html" title="This file includes definitions for IPv6 network interfaces. " alt="" coords="3940,245,4085,271"/>
<area shape="rect" id="node44" href="../../da/db5/mac_8hpp.html" title="This file includes definitions for the IEEE 802.15.4 MAC. " alt="" coords="3712,245,3865,271"/>
<area shape="rect" id="node45" href="../../de/d6e/mac__blacklist_8hpp.html" title="This file includes definitions for IEEE 802.15.4 frame filtering based on MAC address. " alt="" coords="3489,165,3696,191"/>
<area shape="rect" id="node46" href="../../d3/d9e/mac__frame_8cpp.html" title="This file implements IEEE 802.15.4 header generation and processing. " alt="" coords="2888,165,3081,191"/>
<area shape="rect" id="node47" href="../../d6/d79/mac__whitelist_8hpp.html" title="This file includes definitions for IEEE 802.15.4 frame filtering based on MAC address. " alt="" coords="3720,165,3927,191"/>
</map>
</div>
</div>
<p><a href="../../df/d57/encoding_8hpp_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a0cb64877f0b26cb88621b1101fc348e6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0cb64877f0b26cb88621b1101fc348e6"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>BitVectorBytes</b>(x)                  &#160;&#160;&#160;(((x) + (CHAR_BIT-1)) / CHAR_BIT)</td></tr>
<tr class="separator:a0cb64877f0b26cb88621b1101fc348e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a44f44863d36e52cb16e3cd9771e5e4a4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a44f44863d36e52cb16e3cd9771e5e4a4"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::Swap16</b> (uint16_t v)</td></tr>
<tr class="separator:a44f44863d36e52cb16e3cd9771e5e4a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2c4790f550bba318561ad3ac2ebbec9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa2c4790f550bba318561ad3ac2ebbec9"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::Swap32</b> (uint32_t v)</td></tr>
<tr class="separator:aa2c4790f550bba318561ad3ac2ebbec9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab384e880b5f71dd4245697dabf3710b3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab384e880b5f71dd4245697dabf3710b3"></a>
uint64_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::Swap64</b> (uint64_t v)</td></tr>
<tr class="separator:ab384e880b5f71dd4245697dabf3710b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91ad274cf25ce41218f28714cbbeabee"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a91ad274cf25ce41218f28714cbbeabee"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::BigEndian::HostSwap16</b> (uint16_t v)</td></tr>
<tr class="separator:a91ad274cf25ce41218f28714cbbeabee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bcbbdf7f34499d23f084944a6187203"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0bcbbdf7f34499d23f084944a6187203"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::BigEndian::HostSwap32</b> (uint32_t v)</td></tr>
<tr class="separator:a0bcbbdf7f34499d23f084944a6187203"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbd8cfad8eac56b437d379f30a26d6b9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acbd8cfad8eac56b437d379f30a26d6b9"></a>
uint64_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::BigEndian::HostSwap64</b> (uint64_t v)</td></tr>
<tr class="separator:acbd8cfad8eac56b437d379f30a26d6b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c6c99bde9c5a06ea0ba4e0ddef56072"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c6c99bde9c5a06ea0ba4e0ddef56072"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::LittleEndian::HostSwap16</b> (uint16_t v)</td></tr>
<tr class="separator:a1c6c99bde9c5a06ea0ba4e0ddef56072"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d5495b4a2b1e76cbc852ca18adf5893"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4d5495b4a2b1e76cbc852ca18adf5893"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::LittleEndian::HostSwap32</b> (uint32_t v)</td></tr>
<tr class="separator:a4d5495b4a2b1e76cbc852ca18adf5893"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d816ff269255d5bb838b393d3e45611"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8d816ff269255d5bb838b393d3e45611"></a>
uint64_t&#160;</td><td class="memItemRight" valign="bottom"><b>Thread::Encoding::LittleEndian::HostSwap64</b> (uint64_t v)</td></tr>
<tr class="separator:a8d816ff269255d5bb838b393d3e45611"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file includes definitions for byte-ordering encoding. </p>
</div></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_34b4cee2b5900b653deb3438fc906cf4.html">common</a></li><li class="navelem"><a class="el" href="../../df/d57/encoding_8hpp.html">encoding.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:34 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
